---
title: Update an incident user-defined field
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Incidents
---

# Update an incident user-defined field{% #update-an-incident-user-defined-field %}
Copy pageCopied
{% tab title="v2" %}
**Note**: This endpoint is in preview and is subject to change. If you have any feedback, contact [Datadog support](https://docs.datadoghq.com/help/).
| Datadog site      | API endpoint                                                                               |
| ----------------- | ------------------------------------------------------------------------------------------ |
| ap1.datadoghq.com | PATCH https://api.ap1.datadoghq.com/api/v2/incidents/config/user-defined-fields/{field_id} |
| ap2.datadoghq.com | PATCH https://api.ap2.datadoghq.com/api/v2/incidents/config/user-defined-fields/{field_id} |
| app.datadoghq.eu  | PATCH https://api.datadoghq.eu/api/v2/incidents/config/user-defined-fields/{field_id}      |
| app.ddog-gov.com  | PATCH https://api.ddog-gov.com/api/v2/incidents/config/user-defined-fields/{field_id}      |
| us2.ddog-gov.com  | PATCH https://api.us2.ddog-gov.com/api/v2/incidents/config/user-defined-fields/{field_id}  |
| app.datadoghq.com | PATCH https://api.datadoghq.com/api/v2/incidents/config/user-defined-fields/{field_id}     |
| us3.datadoghq.com | PATCH https://api.us3.datadoghq.com/api/v2/incidents/config/user-defined-fields/{field_id} |
| us5.datadoghq.com | PATCH https://api.us5.datadoghq.com/api/v2/incidents/config/user-defined-fields/{field_id} |

### Overview

Update an incident user-defined field. This endpoint requires the `incident_settings_write` permission.

OAuth apps require the `incident_settings_write` authorization [scope](https://docs.datadoghq.com/api/latest/scopes.md#incidents) to access this endpoint.



### Arguments

#### Path Parameters

| Name                       | Type   | Description                                |
| -------------------------- | ------ | ------------------------------------------ |
| field_id [*required*] | string | The ID of the incident user-defined field. |

#### Query Strings

| Name    | Type   | Description                                                                                                                                 |
| ------- | ------ | ------------------------------------------------------------------------------------------------------------------------------------------- |
| include | string | Comma-separated list of related resources to include. Supported values are "last_modified_by_user", "created_by_user", and "incident_type". |

### Request

#### Body Data (required)

Incident user-defined field update payload.

{% tab title="Model" %}

| Parent field | Field                          | Type     | Description                                                                                                                                                                                |
| ------------ | ------------------------------ | -------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ |
|              | data [*required*]         | object   | Data for updating an incident user-defined field.                                                                                                                                          |
| data         | attributes [*required*]   | object   | Attributes for updating an incident user-defined field. All fields are optional.                                                                                                           |
| attributes   | category                       | enum     | The section in which the field appears: "what_happened" or "why_it_happened". When null, the field appears in the Attributes section. Allowed enum values: `what_happened,why_it_happened` |
| attributes   | collected                      | enum     | The lifecycle stage at which the app prompts users to fill out this field. Cannot be set on required fields. Allowed enum values: `active,stable,resolved,completed`                       |
| attributes   | default_value                  | string   | The default value for the field. Must be one of the valid values when valid_values is set.                                                                                                 |
| attributes   | display_name                   | string   | The human-readable name shown in the UI.                                                                                                                                                   |
| attributes   | ordinal                        | string   | A decimal string representing the field's display order in the UI.                                                                                                                         |
| attributes   | required                       | boolean  | When true, users must fill out this field on incidents.                                                                                                                                    |
| attributes   | valid_values                   | [object] | The list of allowed values for dropdown and multiselect fields. Limited to 1000 values.                                                                                                    |
| valid_values | description                    | string   | A detailed description of the valid value.                                                                                                                                                 |
| valid_values | display_name [*required*] | string   | The human-readable display name for this value.                                                                                                                                            |
| valid_values | short_description              | string   | A short description of the valid value.                                                                                                                                                    |
| valid_values | value [*required*]        | string   | The identifier that is stored when this option is selected.                                                                                                                                |
| data         | id [*required*]           | string   | The unique identifier of the user-defined field to update.                                                                                                                                 |
| data         | type [*required*]         | enum     | The incident user defined fields type. Allowed enum values: `user_defined_field`                                                                                                           |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "category": "what_happened",
      "collected": "active",
      "default_value": "critical",
      "display_name": "Root Cause",
      "ordinal": "1.5",
      "required": false,
      "valid_values": [
        {
          "description": "A critical severity incident.",
          "display_name": "Critical",
          "short_description": "Critical",
          "value": "critical"
        }
      ]
    },
    "id": "00000000-0000-0000-0000-000000000000",
    "type": "user_defined_field"
  }
}
```

{% /tab %}

### Response

{% tab title="200" %}
OK
{% tab title="Model" %}
Response containing a single incident user-defined field.

| Parent field          | Field                                   | Type      | Description                                                                                                                                                                                |
| --------------------- | --------------------------------------- | --------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ |
|                       | data [*required*]                  | object    | Data object for an incident user-defined field response.                                                                                                                                   |
| data                  | attributes [*required*]            | object    | Attributes of an incident user-defined field.                                                                                                                                              |
| attributes            | attached_to [*required*]           | string    | The resource type this field is attached to. Always "incidents".                                                                                                                           |
| attributes            | category [*required*]              | enum      | The section in which the field appears: "what_happened" or "why_it_happened". When null, the field appears in the Attributes section. Allowed enum values: `what_happened,why_it_happened` |
| attributes            | collected [*required*]             | enum      | The lifecycle stage at which the app prompts users to fill out this field. Cannot be set on required fields. Allowed enum values: `active,stable,resolved,completed`                       |
| attributes            | created [*required*]               | date-time | Timestamp when the field was created.                                                                                                                                                      |
| attributes            | default_value [*required*]         | string    | The default value for the field.                                                                                                                                                           |
| attributes            | deleted [*required*]               | date-time | Timestamp when the field was soft-deleted, or null if not deleted.                                                                                                                         |
| attributes            | display_name [*required*]          | string    | The human-readable name shown in the UI.                                                                                                                                                   |
| attributes            | metadata [*required*]              | object    | Metadata for autocomplete-type user-defined fields, describing how to populate autocomplete options.                                                                                       |
| metadata              | category [*required*]              | string    | The category of the autocomplete source.                                                                                                                                                   |
| metadata              | search_limit_param [*required*]    | string    | The query parameter used to limit the number of autocomplete results.                                                                                                                      |
| metadata              | search_params [*required*]         | object    | Additional query parameters to include in the search URL.                                                                                                                                  |
| metadata              | search_query_param [*required*]    | string    | The query parameter used to pass typed input to the search URL.                                                                                                                            |
| metadata              | search_result_path [*required*]    | string    | The JSON path to the results in the response body.                                                                                                                                         |
| metadata              | search_url [*required*]            | string    | The URL used to populate autocomplete options.                                                                                                                                             |
| attributes            | modified [*required*]              | date-time | Timestamp when the field was last modified.                                                                                                                                                |
| attributes            | name [*required*]                  | string    | The unique identifier of the field.                                                                                                                                                        |
| attributes            | ordinal [*required*]               | string    | A decimal string representing the field's display order in the UI.                                                                                                                         |
| attributes            | prerequisite [*required*]          | string    | Reserved for future use. Always null.                                                                                                                                                      |
| attributes            | required [*required*]              | boolean   | When true, users must fill out this field on incidents.                                                                                                                                    |
| attributes            | reserved [*required*]              | boolean   | When true, this field is reserved for system use and cannot be deleted.                                                                                                                    |
| attributes            | table_id [*required*]              | int64     | Reserved for internal use. Always 0.                                                                                                                                                       |
| attributes            | tag_key [*required*]               | string    | For metric tag-type fields only, the metric tag key that powers the autocomplete options.                                                                                                  |
| attributes            | type [*required*]                  | int32     | The data type of the field. 1=dropdown, 2=multiselect, 3=textbox, 4=textarray, 5=metrictag, 6=autocomplete, 7=number, 8=datetime.                                                          |
| attributes            | valid_values [*required*]          | [object]  | The list of allowed values for dropdown, multiselect, and autocomplete fields.                                                                                                             |
| valid_values          | description                             | string    | A detailed description of the valid value.                                                                                                                                                 |
| valid_values          | display_name [*required*]          | string    | The human-readable display name for this value.                                                                                                                                            |
| valid_values          | short_description                       | string    | A short description of the valid value.                                                                                                                                                    |
| valid_values          | value [*required*]                 | string    | The identifier that is stored when this option is selected.                                                                                                                                |
| data                  | id [*required*]                    | string    | The unique identifier of the user-defined field.                                                                                                                                           |
| data                  | relationships [*required*]         | object    | Relationships of an incident user-defined field.                                                                                                                                           |
| relationships         | created_by_user [*required*]       | object    | Relationship to user.                                                                                                                                                                      |
| created_by_user       | data [*required*]                  | object    | Relationship to user object.                                                                                                                                                               |
| data                  | id [*required*]                    | string    | A unique identifier that represents the user.                                                                                                                                              |
| data                  | type [*required*]                  | enum      | Users resource type. Allowed enum values: `users`                                                                                                                                          |
| relationships         | incident_type [*required*]         | object    | Relationship to an incident type.                                                                                                                                                          |
| incident_type         | data [*required*]                  | object    | Relationship to incident type object.                                                                                                                                                      |
| data                  | id [*required*]                    | string    | The incident type's ID.                                                                                                                                                                    |
| data                  | type [*required*]                  | enum      | Incident type resource type. Allowed enum values: `incident_types`                                                                                                                         |
| relationships         | last_modified_by_user [*required*] | object    | Relationship to user.                                                                                                                                                                      |
| last_modified_by_user | data [*required*]                  | object    | Relationship to user object.                                                                                                                                                               |
| data                  | id [*required*]                    | string    | A unique identifier that represents the user.                                                                                                                                              |
| data                  | type [*required*]                  | enum      | Users resource type. Allowed enum values: `users`                                                                                                                                          |
| data                  | type [*required*]                  | enum      | The incident user defined fields type. Allowed enum values: `user_defined_field`                                                                                                           |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "attached_to": "incidents",
      "category": "what_happened",
      "collected": "active",
      "created": "2026-03-18T08:40:05.185406Z",
      "default_value": "critical",
      "deleted": null,
      "display_name": "Root Cause",
      "metadata": {
        "category": "teams_and_services",
        "search_limit_param": "page[size]",
        "search_params": {},
        "search_query_param": "filter",
        "search_result_path": "$.data[*].attributes.name",
        "search_url": "/api/v2/incidents/config/services"
      },
      "modified": "2026-03-18T08:40:05.185406Z",
      "name": "root_cause",
      "ordinal": "1.5",
      "prerequisite": null,
      "required": false,
      "reserved": false,
      "table_id": 0,
      "tag_key": null,
      "type": 3,
      "valid_values": [
        {
          "description": "A critical severity incident.",
          "display_name": "Critical",
          "short_description": "Critical",
          "value": "critical"
        }
      ]
    },
    "id": "00000000-0000-0000-0000-000000000000",
    "relationships": {
      "created_by_user": {
        "data": {
          "id": "00000000-0000-0000-2345-000000000000",
          "type": "users"
        }
      },
      "incident_type": {
        "data": {
          "id": "00000000-0000-0000-0000-000000000000",
          "type": "incident_types"
        }
      },
      "last_modified_by_user": {
        "data": {
          "id": "00000000-0000-0000-2345-000000000000",
          "type": "users"
        }
      }
    },
    "type": "user_defined_field"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="401" %}
Unauthorized
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Forbidden
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="404" %}
Not Found
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \## default
# 
 \# Path parameters export field_id="00000000-0000-0000-0000-000000000000" \# Curl command curl -X PATCH "https://api.datadoghq.com/api/v2/incidents/config/user-defined-fields/${field_id}" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "category": "what_happened",
      "collected": "active",
      "default_value": "critical",
      "display_name": "Root Cause",
      "ordinal": "1.5",
      "required": false,
      "valid_values": [
        {
          "description": "A critical severity incident.",
          "display_name": "Critical",
          "short_description": "Critical",
          "value": "critical"
        }
      ]
    },
    "id": "00000000-0000-0000-0000-000000000000",
    "type": "user_defined_field"
  }
}
EOF 
                
##### 

```python
"""
Update an incident user-defined field returns "OK" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.incidents_api import IncidentsApi
from datadog_api_client.v2.model.incident_user_defined_field_attributes_update_request import (
    IncidentUserDefinedFieldAttributesUpdateRequest,
)
from datadog_api_client.v2.model.incident_user_defined_field_category import IncidentUserDefinedFieldCategory
from datadog_api_client.v2.model.incident_user_defined_field_collected import IncidentUserDefinedFieldCollected
from datadog_api_client.v2.model.incident_user_defined_field_type import IncidentUserDefinedFieldType
from datadog_api_client.v2.model.incident_user_defined_field_update_data import IncidentUserDefinedFieldUpdateData
from datadog_api_client.v2.model.incident_user_defined_field_update_request import IncidentUserDefinedFieldUpdateRequest
from datadog_api_client.v2.model.incident_user_defined_field_valid_value import IncidentUserDefinedFieldValidValue

body = IncidentUserDefinedFieldUpdateRequest(
    data=IncidentUserDefinedFieldUpdateData(
        attributes=IncidentUserDefinedFieldAttributesUpdateRequest(
            category=IncidentUserDefinedFieldCategory.WHAT_HAPPENED,
            collected=IncidentUserDefinedFieldCollected.ACTIVE,
            default_value="critical",
            display_name="Root Cause",
            ordinal="1.5",
            required=False,
            valid_values=[
                IncidentUserDefinedFieldValidValue(
                    description="A critical severity incident.",
                    display_name="Critical",
                    short_description="Critical",
                    value="critical",
                ),
            ],
        ),
        id="00000000-0000-0000-0000-000000000000",
        type=IncidentUserDefinedFieldType.USER_DEFINED_FIELD,
    ),
)

configuration = Configuration()
configuration.unstable_operations["update_incident_user_defined_field"] = True
with ApiClient(configuration) as api_client:
    api_instance = IncidentsApi(api_client)
    response = api_instance.update_incident_user_defined_field(
        field_id="00000000-0000-0000-0000-000000000000", body=body
    )

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
##### 

```ruby
# Update an incident user-defined field returns "OK" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.unstable_operations["v2.update_incident_user_defined_field".to_sym] = true
end
api_instance = DatadogAPIClient::V2::IncidentsAPI.new

body = DatadogAPIClient::V2::IncidentUserDefinedFieldUpdateRequest.new({
  data: DatadogAPIClient::V2::IncidentUserDefinedFieldUpdateData.new({
    attributes: DatadogAPIClient::V2::IncidentUserDefinedFieldAttributesUpdateRequest.new({
      category: DatadogAPIClient::V2::IncidentUserDefinedFieldCategory::WHAT_HAPPENED,
      collected: DatadogAPIClient::V2::IncidentUserDefinedFieldCollected::ACTIVE,
      default_value: "critical",
      display_name: "Root Cause",
      ordinal: "1.5",
      required: false,
      valid_values: [
        DatadogAPIClient::V2::IncidentUserDefinedFieldValidValue.new({
          description: "A critical severity incident.",
          display_name: "Critical",
          short_description: "Critical",
          value: "critical",
        }),
      ],
    }),
    id: "00000000-0000-0000-0000-000000000000",
    type: DatadogAPIClient::V2::IncidentUserDefinedFieldType::USER_DEFINED_FIELD,
  }),
})
p api_instance.update_incident_user_defined_field("00000000-0000-0000-0000-000000000000", body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```go
// Update an incident user-defined field returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.IncidentUserDefinedFieldUpdateRequest{
		Data: datadogV2.IncidentUserDefinedFieldUpdateData{
			Attributes: datadogV2.IncidentUserDefinedFieldAttributesUpdateRequest{
				Category:     *datadogV2.NewNullableIncidentUserDefinedFieldCategory(datadogV2.INCIDENTUSERDEFINEDFIELDCATEGORY_WHAT_HAPPENED.Ptr()),
				Collected:    *datadogV2.NewNullableIncidentUserDefinedFieldCollected(datadogV2.INCIDENTUSERDEFINEDFIELDCOLLECTED_ACTIVE.Ptr()),
				DefaultValue: *datadog.NewNullableString(datadog.PtrString("critical")),
				DisplayName:  datadog.PtrString("Root Cause"),
				Ordinal:      *datadog.NewNullableString(datadog.PtrString("1.5")),
				Required:     *datadog.NewNullableBool(datadog.PtrBool(false)),
				ValidValues: []datadogV2.IncidentUserDefinedFieldValidValue{
					{
						Description:      datadog.PtrString("A critical severity incident."),
						DisplayName:      "Critical",
						ShortDescription: datadog.PtrString("Critical"),
						Value:            "critical",
					},
				},
			},
			Id:   "00000000-0000-0000-0000-000000000000",
			Type: datadogV2.INCIDENTUSERDEFINEDFIELDTYPE_USER_DEFINED_FIELD,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.UpdateIncidentUserDefinedField", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewIncidentsApi(apiClient)
	resp, r, err := api.UpdateIncidentUserDefinedField(ctx, "00000000-0000-0000-0000-000000000000", body, *datadogV2.NewUpdateIncidentUserDefinedFieldOptionalParameters())

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `IncidentsApi.UpdateIncidentUserDefinedField`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `IncidentsApi.UpdateIncidentUserDefinedField`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
##### 

```java
// Update an incident user-defined field returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.IncidentsApi;
import com.datadog.api.client.v2.model.IncidentUserDefinedFieldAttributesUpdateRequest;
import com.datadog.api.client.v2.model.IncidentUserDefinedFieldCategory;
import com.datadog.api.client.v2.model.IncidentUserDefinedFieldCollected;
import com.datadog.api.client.v2.model.IncidentUserDefinedFieldResponse;
import com.datadog.api.client.v2.model.IncidentUserDefinedFieldType;
import com.datadog.api.client.v2.model.IncidentUserDefinedFieldUpdateData;
import com.datadog.api.client.v2.model.IncidentUserDefinedFieldUpdateRequest;
import com.datadog.api.client.v2.model.IncidentUserDefinedFieldValidValue;
import java.util.Collections;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setUnstableOperationEnabled("v2.updateIncidentUserDefinedField", true);
    IncidentsApi apiInstance = new IncidentsApi(defaultClient);

    IncidentUserDefinedFieldUpdateRequest body =
        new IncidentUserDefinedFieldUpdateRequest()
            .data(
                new IncidentUserDefinedFieldUpdateData()
                    .attributes(
                        new IncidentUserDefinedFieldAttributesUpdateRequest()
                            .category(IncidentUserDefinedFieldCategory.WHAT_HAPPENED)
                            .collected(IncidentUserDefinedFieldCollected.ACTIVE)
                            .defaultValue("critical")
                            .displayName("Root Cause")
                            .ordinal("1.5")
                            .required(false)
                            .validValues(
                                Collections.singletonList(
                                    new IncidentUserDefinedFieldValidValue()
                                        .description("A critical severity incident.")
                                        .displayName("Critical")
                                        .shortDescription("Critical")
                                        .value("critical"))))
                    .id("00000000-0000-0000-0000-000000000000")
                    .type(IncidentUserDefinedFieldType.USER_DEFINED_FIELD));

    try {
      IncidentUserDefinedFieldResponse result =
          apiInstance.updateIncidentUserDefinedField("00000000-0000-0000-0000-000000000000", body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling IncidentsApi#updateIncidentUserDefinedField");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
##### 

```rust
// Update an incident user-defined field returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_incidents::IncidentsAPI;
use datadog_api_client::datadogV2::api_incidents::UpdateIncidentUserDefinedFieldOptionalParams;
use datadog_api_client::datadogV2::model::IncidentUserDefinedFieldAttributesUpdateRequest;
use datadog_api_client::datadogV2::model::IncidentUserDefinedFieldCategory;
use datadog_api_client::datadogV2::model::IncidentUserDefinedFieldCollected;
use datadog_api_client::datadogV2::model::IncidentUserDefinedFieldType;
use datadog_api_client::datadogV2::model::IncidentUserDefinedFieldUpdateData;
use datadog_api_client::datadogV2::model::IncidentUserDefinedFieldUpdateRequest;
use datadog_api_client::datadogV2::model::IncidentUserDefinedFieldValidValue;

#[tokio::main]
async fn main() {
    let body = IncidentUserDefinedFieldUpdateRequest::new(IncidentUserDefinedFieldUpdateData::new(
        IncidentUserDefinedFieldAttributesUpdateRequest::new()
            .category(Some(IncidentUserDefinedFieldCategory::WHAT_HAPPENED))
            .collected(Some(IncidentUserDefinedFieldCollected::ACTIVE))
            .default_value(Some("critical".to_string()))
            .display_name("Root Cause".to_string())
            .ordinal(Some("1.5".to_string()))
            .required(Some(false))
            .valid_values(Some(vec![IncidentUserDefinedFieldValidValue::new(
                "Critical".to_string(),
                "critical".to_string(),
            )
            .description("A critical severity incident.".to_string())
            .short_description("Critical".to_string())])),
        "00000000-0000-0000-0000-000000000000".to_string(),
        IncidentUserDefinedFieldType::USER_DEFINED_FIELD,
    ));
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled("v2.UpdateIncidentUserDefinedField", true);
    let api = IncidentsAPI::with_config(configuration);
    let resp = api
        .update_incident_user_defined_field(
            "00000000-0000-0000-0000-000000000000".to_string(),
            body,
            UpdateIncidentUserDefinedFieldOptionalParams::default(),
        )
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
##### 

```typescript
/**
 * Update an incident user-defined field returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
configuration.unstableOperations["v2.updateIncidentUserDefinedField"] = true;
const apiInstance = new v2.IncidentsApi(configuration);

const params: v2.IncidentsApiUpdateIncidentUserDefinedFieldRequest = {
  body: {
    data: {
      attributes: {
        category: "what_happened",
        collected: "active",
        defaultValue: "critical",
        displayName: "Root Cause",
        ordinal: "1.5",
        required: false,
        validValues: [
          {
            description: "A critical severity incident.",
            displayName: "Critical",
            shortDescription: "Critical",
            value: "critical",
          },
        ],
      },
      id: "00000000-0000-0000-0000-000000000000",
      type: "user_defined_field",
    },
  },
  fieldId: "00000000-0000-0000-0000-000000000000",
};

apiInstance
  .updateIncidentUserDefinedField(params)
  .then((data: v2.IncidentUserDefinedFieldResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"
{% /tab %}
